#!/bin/csh

set opsys = `uname`

# SunOS or Solaris?
if ($opsys == "SunOS") then
    set opsys = $opsys-`uname -r | cut -d. -f1`
endif

switch ($opsys)
    case "IRIX":
	set arch = irix5.3
	breaksw
    case "SunOS-4":
	set arch = sunos4.1
	# This won't work quite so well since snoopy went solaris...
	breaksw
    case "SunOS-5":
	set arch = solaris2.5
	breaksw
    case "Linux":
	set arch = linux
	breaksw
endsw

setenv KQML_HOME /usr/local/src/kqml
setenv KQML_ARCH $KQML_HOME/ARCH/$arch

setenv KQML_DBG $KQML_HOME/log
setenv KQML_DBG_LEVEL 11

setenv KQML_ROUTER $KQML_ARCH/bin/router
setenv KQML_VALIDATOR $KQML_ARCH/bin/validator

setenv KQML_ANS "snoopy.cs.umbc.edu:5500:"

setenv SP_PATH $KQML_HOME/lib/Runtime		#For SICStus Prolog runtime
setenv PATH "${PATH}:${KQML_ARCH}/bin"
rehash
