#include <stdio.h>
#include <string.h>
#include <strings.h>

#include <kqml.h>

/******	This subroutine searches for the ANS substring in the agent name.
			Necessary for navigating through the hierarchy of ANSs.
			-- Anupama.  ******/

int search_for_ans(char *agent, char *ANS, char **sear_str)
{
	char	*dupagent, *dupans, *ans_str;

	if ((dupans = strdup(ANS)) == NULL)
	{
		fprintf (stderr, "Error in duplicating ANS name.\n");
		return -1;
	}

	if ((dupagent = strdup(agent)) == NULL)
	{
		fprintf (stderr, "Error in duplicating agent name.\n");
		return -1;
	}

	dupans = strtok(dupans, ".");
	ans_str = strtok(dupagent, ".");

	if ((*sear_str = strdup(agent)) == NULL)
	{
		fprintf (stderr, "Error in initializing the value of the search 
					string.\n");
		return -1;
	}

	while (ans_str && strcmp(ans_str, dupans) != 0)
	{
		ans_str = strtok(NULL, ".");
		*sear_str = strchr(*sear_str, '.');
		(*sear_str)++;
	}

	if (ans_str == NULL)
	{
		*sear_str = NULL;
		_kqml_dbg_msg (KQML_DBG_VERBOSE) ("Search-for-ans : Unsuccessful.");
		return -1;
	}

	_kqml_dbg_msg (KQML_DBG_VERBOSE) 
		("Search-for-ans : Successful -[%s].", *sear_str);
	return 1;
}
