(use-package :kqml)

(defun agent (agent-name)
  (if (<= (kqml-initialize agent-name nil) -1)
      (progn
	  (format t "~%Error in initializing~%")
	  (return-from agent)))
  (kqml-dbg-msg "Finished init....to register handlers")
  (if (<= (kqml-register 'ask-all-handler 'ask-all 1) -1)
      (progn
	  (format t "~%Error in registering the ask-all handler~%")
	  (return-from agent)))
  (if (<= (kqml-register 'tell-handler 'tell 1) -1)
      (progn
	(format t "~%Error in registering the tell handler~%")
	(return-from agent)))
  (format t "~%Registered the handlers~%")

  (setf embed_msg (kqml-build-msg 'ask-one "" "" "" 'language 'cycl))
  (setf kqml_msg (kqml-build-msg 'advertise "" "Anupama" 't
				 'language "KQML" 'sender agent-name))
  (setf kqml_msg (kqml-put-embedded-msg 'content kqml_msg embed_msg))
  (format t "~%Built the kqml message~%")
  (kqml-print-msg kqml_msg)

  (setf reply_msg (kqml-send -1 kqml_msg))
  (if (not (or
	    (equal (string (kqml-get-field 'reply-with kqml_msg)) "NIL")
	    (equal (string (kqml-get-field 'reply-with kqml_msg)) "nil")))
      (progn
	(format t "~%Reply Received from [~a]"
		(kqml-get-field 'sender reply_msg))
	(setf content (kqml-get-field 'content reply_msg))
	(format t "~%Content : [~S]~%" content)))
  (loop
   (format t "Enter something : ")
   (setf str-var (read))
   (format t "~%[~S]~%" str-var)
   (if (eq str-var -1) (return))))

(defun ask-all-handler (content kqml-mesg)
  (format t "~%In ask-all-handler~%")
  (kqml-print-msg kqml-mesg)
  (setf reply-msg (kqml-build-msg 'reply "All's well in ask-all-handler"
				  (kqml-get-field :sender kqml-mesg)
				  'nil))
  (list reply-msg))

(defun tell-handler (content kqml-mesg)
  (format t "~%In tell-handler~%")
  (kqml-print-msg kqml-mesg)
  (setf reply-msg (kqml-build-msg 'reply "All's well in tell-handler"
				  (kqml-get-field :sender kqml-mesg)
				  'nil))
  (list reply-msg))

(defun stop-kqml (agent-name)
  (setf kmsg (kqml-build-msg 'unregister
		     (format nil "(~a ~a ~a)" agent-name (machine-instance) 0)
		     "KQMLfacilitator" 'nil))
  (setf reply (kqml-send -1 kmsg))
  (if (null reply)
      (format t "~%Stop-KQML : Unregister failed.~%")))
